=== editors/scel/CMakeLists.txt ===
add_subdirectory(el)
add_subdirectory(sc)
