=== debian/changelog ===
supercollider (1:3.6.3~repack-5) unstable; urgency=medium

  * Do not use system yaml-cpp. Closes: #733277

 -- Felipe Sateler <fsateler@debian.org>  Fri, 03 Jan 2014 13:11:22 -0300

supercollider (1:3.6.3~repack-4) unstable; urgency=low

  [ Dan Stowell ]
  * Use system libyaml-cpp0.3 (Closes: #722430)
  * Do not build/provide supernova on sparc/powerpc (Closes: #728573)

 -- Felipe Sateler <fsateler@debian.org>  Sun, 24 Nov 2013 12:50:24 -0300

supercollider (1:3.6.3~repack-3) unstable; urgency=low

  * Force use of bundled yaml-cpp
  * Add patch to use system lockfree. Also link appropriate libs on all archs

 -- Felipe Sateler <fsateler@debian.org>  Thu, 12 Sep 2013 19:21:30 -0300

supercollider (1:3.6.3~repack-2) unstable; urgency=low

  [ Dan Stowell ]
  * Add 2 more files needed in -dev: SCVersion.txt, SC_PlugIn.hpp

  [ Felipe Sateler ]
  * Drop alternative build dependencies on specific libboost versions
  * Bump standards version
  * Upload to unstable

 -- Felipe Sateler <fsateler@debian.org>  Mon, 09 Sep 2013 22:06:01 -0300

supercollider (1:3.6.3~repack-1) experimental; urgency=low

  [ Dan Stowell ]
  * Imported upstream version 3.6.3
  * Rename language package supercollider -> supercollider-language
  * supercollider is now a metapackage to provide standard install

  [ Felipe Sateler ]
  * Improve supercollider-supernova description.

 -- Felipe Sateler <fsateler@debian.org>  Mon, 11 Mar 2013 09:22:37 -0400

supercollider (1:3.6.1~repack) unstable; urgency=low

  * Imported upstream version 3.6.1
  * New "supercollider-ide" package for new Qt-based IDE
  * Ensure build with system boost, and now v1.50+ is required
  * Update/refresh patches, remove 4 outdated patches
  * Update copyright file
  * Update install files: supernova plugin path changed
  * Add cmake flags to ensure libscsynth is built (while testsuite not, unneeded)
  * supernova compile fix on x86

 -- Dan Stowell <danstowell@users.sourceforge.net>  Thu, 20 Dec 2012 19:22:39 +0000

supercollider (1:3.5.4~repack-2-2) unstable; urgency=low

  * Imported upstream version 3.5.4
  * Note copyright for added file git-archive-all.py

 -- Dan Stowell <danstowell@users.sourceforge.net>  Mon, 13 Aug 2012 14:07:48 +0100
